/*
    $Id: ppdpair.h 1107 2007-04-16 23:59:13Z rvernica $

    Copyright (C) 2007 by The Regents of the University of California

    Redistribution of this file is permitted under the terms of the
    GNU Public License (GPL).

    Date: 01/14/2006
    Author: Rares Vernica <rvernica@ics.uci.edu>
*/

#ifndef _ppdpair_h_
#define _ppdpair_h_

#include <set>

#include "simfunc/simdist.h"
#include "simfunc/simvect.h"

using namespace std;

class PPDPair {
public:
  SimVect vect1, vect2;
  SimType maxD;
  unsigned countP;

  PPDPair(SimVect v1, SimVect v2, SimType mD): 
    vect1(v1), vect2(v2), maxD(mD), countP(1) {}

  friend ostream& operator<<(ostream &out, const PPDPair &p);
  friend bool operator<(const PPDPair &left, const PPDPair &right);
};

typedef set<PPDPair> SetPPDPair;
typedef SetPPDPair::iterator SetPPDPairIt;

#endif
